#ifndef __BDF_H__
#define __BDF_H__
#include <fstream>
#include <sstream>
#include <string>
#include "stdhdrs.h"

using std::istringstream ;
using std::istream ;
using std::string ;
using std::ofstream ;
extern ofstream fout ;

struct FontTree {
	static const int NUM_CHARS = 256 ;
	static const int MAX_ROWS = 36 ;
	static const int MAX_COLS = 32 ;

	bool font[NUM_CHARS][MAX_ROWS][MAX_COLS] ;
	int fontWidth, fontHeight, fontx, fonty ;
	int bbxw, bbxh, bbxx, bbxy ;

    // Each path in the font tree corresponds to a character bitmap traversed
    // in raster order.
	struct FontTreeNode {
		int value ;
		FontTreeNode* next[2] ;

		FontTreeNode () {
			value = -1 ;
			next[0] = next[1] = NULL ;
		}
	} ;

	FontTreeNode* root ;

	FontTree () ;
	void readBDF (char* filename) ;
	string recognizeText (HDC hdc, POINT pointer) ;
	char searchTree (HDC hdc, int x, int y, COLORREF bg) ;
	void parseBDF (char* filename) ;
	void addToFontTree () ;
	istringstream& nextLine (istream& fin) ;
	void parseRow (int currFontChar, int currRow, unsigned int rowData) ;
} ;

extern FontTree fontTree ;
#endif
